//2008 - Marcelo Archanjo - marcelo_archanjo@yahoo.com.br - this source code is under General Public License.

#include "Main.h"



INT WINAPI WinMain(HINSTANCE hInstance, HINSTANCE, PSTR, INT iCmdShow)
	{
	GdiplusStartupInput gdiplusStartupInput;
	ULONG_PTR           gdiplusToken;
   
	hInstanceSave=hInstance;
  
	// Initialize GDI+.
	GdiplusStartup(&gdiplusToken, &gdiplusStartupInput, NULL);
	
   	
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG1),NULL,DialogProc);
	deleteBuffer();
	GdiplusShutdown(gdiplusToken);
	return true;
	}  // WinMain



void enableItem(HWND hDlg,int dlgItem,bool enable)
	{
	HWND hwnditem=GetDlgItem (hDlg,dlgItem);
	EnableWindow(hwnditem,enable);
	}



bool getData(HWND hDlg,int dlgItem)
	{
	WCHAR argument[256];

	GetDlgItemText(hDlg, dlgItem, argument, sizeof(argument));

	//swscanf(argument,L"%s %s %d %d %d %c %d %d",GleftFile,GrightFile,&GmaxDisp,&GmaxLineVar,&GwindowSize,&GintensityOrGradient,&VERTS_PER_EDGE_WIDTH,&VERTS_PER_EDGE_HEIGHT);
	swscanf_s(argument,L"%s %s %d %d %d %c %d %d",GleftFile,_countof(GleftFile),GrightFile,_countof(GrightFile),&GmaxDisp,&GmaxLineVar,&GwindowSize,&GintensityOrGradient,sizeof(WCHAR),&VERTS_PER_EDGE_WIDTH,&VERTS_PER_EDGE_HEIGHT);

	//composio do nome do mapa de disparidades	
	LPCTSTR pszFormat = TEXT("%s_%d_%d_%d_%c.BMP");
	StringCbPrintfW(GdisparityMap, (256*sizeof(WCHAR)),pszFormat,GleftFile,GmaxDisp,GmaxLineVar,GwindowSize,GintensityOrGradient);
	if(compare)
		{
		LPCTSTR pszFormat = TEXT("%s_%d_%d_%d_%c_Trad.BMP");
		StringCbPrintfW(disparityMap, (256*sizeof(WCHAR)),pszFormat,GleftFile,GmaxDisp,GmaxLineVar,GwindowSize,GintensityOrGradient);
		}


	//composio do nome do arquivo 3D exportado em VRML	
	LPCTSTR pszFormat2 = TEXT("%s_%d_%d_%d_%c_%d_%d.WRL");
	StringCbPrintfW(GVRMLfile, (256*sizeof(WCHAR)),pszFormat2,GleftFile,GmaxDisp,GmaxLineVar,GwindowSize,GintensityOrGradient,VERTS_PER_EDGE_WIDTH,VERTS_PER_EDGE_HEIGHT);

	

	if(!exist(GleftFile)) {ErrorMessage(GleftFile,L"file not found.");return false;}
	if(!exist(GrightFile)) {ErrorMessage(GrightFile,L"file not found.");return false;}
    if(GmaxDisp<1)		{ErrorMessage(GmaxDisp,L"no  um Max Disparity vlido, pois  menor que 1.");return false;}
	if(GmaxLineVar<1)	{ErrorMessage(GmaxLineVar,L"no  um Max Line Variation vlido, pois  menor que 1.");return false;}
	if(GmaxLineVar%2==0)	{ErrorMessage(GmaxLineVar,L"no  um Max Line Variation vlido, pois  um nmero par.");return false;}
	if(GwindowSize%2==0)	{ErrorMessage(GwindowSize,L"no  um Window Size vlido, pois  um nmero par.");return false;}
	if(GwindowSize<3)	{ErrorMessage(GwindowSize,L"no  um Window Size vlido, pois  menor que 3.");return false;}
	if((GintensityOrGradient!='I')&&(GintensityOrGradient!='G')) {ErrorMessage(L"Caracter Invalido.\n",L"Use I para Intensidade ou G para Gradiente.");return false;}
	if(VERTS_PER_EDGE_WIDTH<2)		{ErrorMessage(VERTS_PER_EDGE_WIDTH,L"No  vlido, pois  menor que 2.");return false;}
	if(VERTS_PER_EDGE_HEIGHT<2)		{ErrorMessage(VERTS_PER_EDGE_HEIGHT,L"No  vlido, pois  menor que 2.");return false;}

	if(GintensityOrGradient=='G') gradient=true;
	else gradient=false;
	


	//variaveis usadas em D3D9.CPP
	g_dwNumVertices = VERTS_PER_EDGE_WIDTH * VERTS_PER_EDGE_HEIGHT;
	g_dwNumIndices = 6 * (VERTS_PER_EDGE_WIDTH - 1) * (VERTS_PER_EDGE_HEIGHT - 1);


	//recent com 10 itens, ordenados pelo mais recente(de cima para baixo) e sem itens repetidos
	//Salva argumentos em last.txt, somente se for novo, e se j foi usado, passa a ser o primeiro da lista

	int numberOfRecents=0;
	int i;
	bool already=false;
	int itemRepetido=-1;
	lastArguments last[10];

	numberOfRecents=load10Recent("last.txt",&last[0]);
	//ErrorMessage(numberOfRecents,GleftFile);

	for(i=0;((i<numberOfRecents)&&(already==false));i++)
		{
		if(	(wcscmp(GleftFile,last[i].leftFile)==0)&&
			(wcscmp(GrightFile,last[i].rightFile)==0)&&
			(GmaxDisp==last[i].maxDisp)&&
			(GmaxLineVar==last[i].maxLineVar)&&
			(GwindowSize==last[i].windowSize)&& 
			(GintensityOrGradient==last[i].intensityOrGradient)&&
			(VERTS_PER_EDGE_WIDTH==last[i].VertsPerEdgeWidth)&&
			(VERTS_PER_EDGE_HEIGHT==last[i].VertsPerEdgeHeight)	) {already=true; itemRepetido=i;}
		}

	

	
	WCHAR text[512];
	LPCTSTR pszFormat1 = TEXT("%s %s %u %u %u %c %u %u\n");
	StringCbPrintfW(text, (512*sizeof(WCHAR)),pszFormat1,GleftFile,GrightFile,GmaxDisp,GmaxLineVar,GwindowSize,GintensityOrGradient,VERTS_PER_EDGE_WIDTH,VERTS_PER_EDGE_HEIGHT);
	logW("last.txt",text);

	if(numberOfRecents==10)
		for(i=0;i<numberOfRecents-1;i++)//perde o ltimo
			{
			if(i!=itemRepetido)
				{
				StringCbPrintfW(text, (512*sizeof(WCHAR)),pszFormat1,last[i].leftFile,last[i].rightFile,last[i].maxDisp,last[i].maxLineVar,last[i].windowSize,last[i].intensityOrGradient,last[i].VertsPerEdgeWidth,last[i].VertsPerEdgeHeight);
				log("last.txt",text);
				}
			}
			
	else
		for(i=0;i<numberOfRecents;i++)
			{
			if(i!=itemRepetido)
				{
				StringCbPrintfW(text, (512*sizeof(WCHAR)),pszFormat1,last[i].leftFile,last[i].rightFile,last[i].maxDisp,last[i].maxLineVar,last[i].windowSize,last[i].intensityOrGradient,last[i].VertsPerEdgeWidth,last[i].VertsPerEdgeHeight);
				log("last.txt",text);
				}
			}

	
	return true;
	}

	
bool getOnlyDispMap(HWND hDlg,int dlgItem)
	{
	WCHAR argument[256];
	
	
	GetDlgItemText(hDlg, dlgItem, argument, sizeof(argument));


	//swscanf(argument,L"%s %s %d %d",GdisparityMap,GleftFile,&VERTS_PER_EDGE_WIDTH,&VERTS_PER_EDGE_HEIGHT);
	swscanf_s(argument,L"%s %s %d %d",GdisparityMap,_countof(GdisparityMap),GleftFile,_countof(GleftFile),&VERTS_PER_EDGE_WIDTH,&VERTS_PER_EDGE_HEIGHT);
	if(!exist(GdisparityMap))	{ErrorMessage(GdisparityMap,L"file not found.");return false;}
	if(!exist(GleftFile))		{ErrorMessage(GleftFile,L"file not found.");return false;}
	if(VERTS_PER_EDGE_WIDTH<2)	{ErrorMessage(VERTS_PER_EDGE_WIDTH,L"No  vlido, pois  menor que 2.");return false;}
	if(VERTS_PER_EDGE_HEIGHT<2)	{ErrorMessage(VERTS_PER_EDGE_HEIGHT,L"No  vlido, pois  menor que 2.");return false;}


	

	
	//composio do nome do arquivo 3D exportado em VRML	
	PCTSTR pszFormat = TEXT("%s_%s_%d_%d.WRL");
	StringCbPrintfW(GVRMLfile, (256*sizeof(WCHAR)),pszFormat,GdisparityMap,GleftFile,VERTS_PER_EDGE_WIDTH,VERTS_PER_EDGE_HEIGHT);


	

	
	//variaveis usadas em D3D9.CPP
	//VERTS_PER_EDGE_WIDTH=64;
	//VERTS_PER_EDGE_HEIGHT=64;
	g_dwNumVertices = VERTS_PER_EDGE_WIDTH * VERTS_PER_EDGE_HEIGHT;
	g_dwNumIndices = 6 * (VERTS_PER_EDGE_WIDTH - 1) * (VERTS_PER_EDGE_HEIGHT - 1);

	//Alocao de memria para o Mapa de Disparidades
	
	
	dispGenerated=true;//mimetismo com a funo CorrespSearch(), porm somente indica para paint() ser o bitmap, no significa que voidDispMap esteja carregado
	LoadOnlyDispMap=true;//indica que em paint() deve ser carregado o buffer voidDispMap e variveis globais necessrias
	return true;
	}


void load10RecentInComboBox(HWND hDlg,int dlgItem)
	{
	lastArguments last[10];
	int i,numberOfRecents=0;



	numberOfRecents=load10Recent("last.txt",&last[0]);

	WCHAR text[512];
	LPCTSTR pszFormat = TEXT("%s %s %u %u %u %c %u %u");
	
	//log("last2.txt",text);

	SendDlgItemMessage( hDlg, dlgItem,   CB_RESETCONTENT, 0, 0 );


	if(numberOfRecents!=0)
		{
		WPARAM dwItem;
		for(i=0;i<numberOfRecents;i++)
			{
			StringCbPrintfW(text, (512*sizeof(WCHAR)),pszFormat,last[i].leftFile,last[i].rightFile,last[i].maxDisp,last[i].maxLineVar,last[i].windowSize,last[i].intensityOrGradient,last[i].VertsPerEdgeWidth,last[i].VertsPerEdgeHeight);
			dwItem = SendDlgItemMessage( hDlg, dlgItem, CB_ADDSTRING, 0,(LPARAM)text);
			SendDlgItemMessage( hDlg, dlgItem, CB_SETITEMDATA,(WPARAM)dwItem, (LPARAM)i);
			}//for(i=0;i<numberOfRecents;i++)
		}
	}

int load10Recent(char *file,lastArguments *last)
	{
	int i=0,returned=-2;
	FILE *fileptr;
	errno_t err;
	if( (err  = fopen_s( &fileptr, file, "r" )) ==0 )
	//if((fileptr=fopen(file,"r")) != NULL)
		{
		returned=10;//no pode ser 0 ou -1
		for(i=0;((i<10)&&(returned!=EOF)&&(returned!=0));i++)//returned=0 indica que a leitura no obteve dados
			{
			//returned=fwscanf(fileptr,L"%s %s %d %d %d %c %d %d",last[i].leftFile,last[i].rightFile,&last[i].maxDisp,&last[i].maxLineVar,&last[i].windowSize,&last[i].intensityOrGradient,&last[i].VertsPerEdgeWidth,&last[i].VertsPerEdgeHeight);
			returned=fwscanf_s(fileptr,L"%s %s %d %d %d %c %d %d",last[i].leftFile,_countof(last[i].leftFile),last[i].rightFile,_countof(last[i].rightFile),&last[i].maxDisp,&last[i].maxLineVar,&last[i].windowSize,&last[i].intensityOrGradient,sizeof(WCHAR),&last[i].VertsPerEdgeWidth,&last[i].VertsPerEdgeHeight);
			//ErrorMessage(i,last[i].leftFile);
			}
		fclose(fileptr);
		}
	if((returned==EOF)||(returned==0)) return i-1;//nestas duas situaes o contador atingiu um valor que no representa uma leitura vlida
	else return i;
	}
/*
void loadRecentInComboBox(HWND hDlg,int dlgItem)
	{
	WCHAR leftFile[256];
	WCHAR rightFile[256];
	int maxDisp;
	int maxLineVar;
	int windowSize;
	WCHAR intensityOrGradient;
	DWORD VertsPerEdgeWidth;//=32;
	DWORD VertsPerEdgeHeight;//=32;



	loadRecent("last.txt",leftFile,rightFile,&maxDisp,&maxLineVar,&windowSize,&intensityOrGradient,&VertsPerEdgeWidth,&VertsPerEdgeHeight);

	WCHAR text[512];
	LPCTSTR pszFormat = TEXT("%s %s %u %u %u %c %u %u");
	StringCbPrintfW(text, (512*sizeof(WCHAR)),pszFormat,leftFile,rightFile,maxDisp,maxLineVar,windowSize,intensityOrGradient,VertsPerEdgeWidth,VertsPerEdgeHeight);
	//log("last2.txt",text);

	SendDlgItemMessage( hDlg, dlgItem,   CB_RESETCONTENT, 0, 0 );

	//char text[512];

	//sprintf(text,"%s %s %u %u %u",leftFile,rightFile,maxDisp,maxLineVar,windowSize);

	WPARAM dwItem;
	//for(i=0;i<37;i++)
	//	{
	    dwItem = SendDlgItemMessage( hDlg, dlgItem, CB_ADDSTRING, 0,(LPARAM)text);
		SendDlgItemMessage( hDlg, dlgItem, CB_SETITEMDATA,(WPARAM)dwItem, (LPARAM)0);
	//	}//fecha for(i=0;i<3;i++)
	}





void loadRecent(char *file,WCHAR *leftFile,WCHAR *rightFile,int *maxDisp,int *maxLineVar,int *windowSize,WCHAR *intensityOrGradient,DWORD *VertsPerEdgeWidth,DWORD *VertsPerEdgeHeight)
	{
	FILE *fileptr;
	errno_t err;
	if( (err  = fopen_s( &fileptr, file, "r" )) ==0 )
	//if((fileptr=fopen(file,"r")) != NULL)
		{
		//fwscanf(fileptr,L"%s %s %d %d %d %c %d %d",leftFile,rightFile,maxDisp,maxLineVar,windowSize,intensityOrGradient,VertsPerEdgeWidth,VertsPerEdgeHeight);
		fwscanf_s(fileptr,L"%s %s %d %d %d %c %d %d",leftFile,256,rightFile,256,maxDisp,maxLineVar,windowSize,intensityOrGradient,sizeof(WCHAR),VertsPerEdgeWidth,VertsPerEdgeHeight);
		fclose(fileptr);
		}
	}*/

void ErrorMessage(int number,WCHAR *message)
	{
	WCHAR text[512];
	LPCTSTR pszFormat1 = TEXT("%d %s");
	StringCbPrintfW(text, (512*sizeof(WCHAR)),pszFormat1,number,message);
	MessageBox(NULL,text,L"Argument Error",MB_OK);	
	}

void ErrorMessage(WCHAR *name,WCHAR *message)
	{
	WCHAR text[512];
	LPCTSTR pszFormat1 = TEXT("%s %s");
	StringCbPrintfW(text, (512*sizeof(WCHAR)),pszFormat1,name,message);
	MessageBox(NULL,text,L"Argument Error",MB_OK);	
	}

bool exist(WCHAR *file)
{
	FILE *pont;
	errno_t err;
	if( (err  =_wfopen_s( &pont,file,L"r" )) ==0 )
	//if ((pont=_wfopen(file,L"r"))!=0)//if existir o arquivo
		{fclose(pont);
		return true;}
	return false;
}

BOOL CALLBACK DialogProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
	{
	HDC          hdc;
    PAINTSTRUCT  ps;

	switch (uMsg)
		{
		case WM_INITDIALOG:
			{
			hDialog = hDlg;
			load10RecentInComboBox(hDlg,IDC_COMBO1);
			//InitD3D9(hInstanceSave);
			//MessageBox(NULL,L"teste",L"teste",MB_OK);
			break;
			}

		case WM_DRAWITEM:
			break;

		case WM_PAINT:
			{
			hdc = BeginPaint(hDlg, &ps);
			paint(hdc);
			EndPaint(hDlg, &ps);
			break;
			}

		case WM_ACTIVATE:// WM_SETCURSOR: Tentativa de recarregar a imagem quando ganha foco
			{//if(show) render(hDlg);
			break;}

		case WM_DESTROY:
			{EndDialog(hDlg, TRUE);
			//deleteBuffer();
			break;}

		case WM_CLOSE://Fecha
			{
			EndDialog(hDlg, TRUE);
			//deleteBuffer();
			PostQuitMessage(1);//fecha tambm a parte DirectX
			return true;
			}

		case WM_COMMAND:
			{
			
			switch (GET_WM_COMMAND_ID(wParam, lParam))
				{
				case IDCLOSE:
					{EndDialog(hDlg, TRUE);
					//deleteBuffer();
					PostQuitMessage(1);//fecha tambm a parte DirectX
					break;}

				case IDC_LOAD:
					{
					if(IsDlgButtonChecked(hDlg,IDC_CHECK_COMPARE)==BST_CHECKED) compare=true;
					else compare=false;


					if(getData(hDlg,IDC_COMBO1))
						{
						enableItem(hDlg,IDGEN,true);
						enableItem(hDlg,IDC_CHECK_COMPARE,false);//bloqueia combo depois da leitura
						imagesLoaded=true;

						hdc = BeginPaint(hDlg, &ps);
						paint(hdc);
						EndPaint(hDlg, &ps);
						}
					
					break;
					}	

				case IDC_LOAD_DISP_MAP:
					{
					if(getOnlyDispMap(hDlg,IDC_COMBO2))
						{
						enableItem(hDlg,ID3D,true);
						imagesLoaded=false;

						hdc = BeginPaint(hDlg, &ps);
						paint(hdc);
						EndPaint(hDlg, &ps);

						//s para dar um refresh na tela, no consegui de outra maneira, mas est funcionando. Tive que mover a janela 1 pixel  direita. 
					
						RECT diagRect;
						GetWindowRect(hDlg,&diagRect);
						MoveWindow(hDlg,diagRect.left+1,diagRect.top,diagRect.right-diagRect.left+1,diagRect.bottom-diagRect.top,true);
						}
					
					break;
					}	
				
				case ID3D:
					{
					enableItem(hDlg,IDC_WIRE,true);
					enableItem(hDlg,IDC_IMAGE_DISP,true);

					InitD3D9(hInstanceSave);
					break;
					}

				case IDC_WIRE:
					{
					if(wire) wire=false;
					else wire=true;
					
					//if(d3d9Active) SetFocus( d3dHWNDsave );
					SetFocus( d3dHWNDsave );
					break;
					}

				case IDC_IMAGE_DISP:
					{
					if(image) {image=false;
								changeImageDisp=true;}
					else	{image=true;
							changeImageDisp=true;}
					
					SetFocus( d3dHWNDsave );
	
					break;
					}

					

				case IDGEN:
					{
					enableItem(hDlg,ID3D,true);

					hdc = BeginPaint(hDlg, &ps);
					FastCorrespSearch(hdc,globalWidth,globalHeight,GmaxDisp,GmaxLineVar,GwindowSize);
					if(compare)
						{
						windowSizeForCompare=GwindowSize;
						matchingCost(hdc,globalWidth,globalHeight,GmaxDisp);
						}

					paint(hdc);
					EndPaint(hDlg, &ps);

					//s para dar um refresh na tela, no consegui de outra maneira, mas est funcionando. Tive que mover a janela 1 pixel  direita. 
					
					RECT diagRect;
					GetWindowRect(hDlg,&diagRect);
					MoveWindow(hDlg,diagRect.left+1,diagRect.top,diagRect.right-diagRect.left+1,diagRect.bottom-diagRect.top,true);
    
					if(compare==false)
						{
						WCHAR text[60];
						LPCTSTR pszFormat1 = TEXT("Time :%2.3fs\n");
						StringCbPrintfW(text, (60*sizeof(WCHAR)),pszFormat1,durationST/CLOCKS_PER_SEC);
						SetDlgItemText(hDialog, IDC_STATIC_TIME,text);
						}
					else
						{
						WCHAR text[60];
						LPCTSTR pszFormat1 = TEXT("ST :%2.3fs\nTrad :%2.3fs\n");
						StringCbPrintfW(text, (60*sizeof(WCHAR)),pszFormat1,durationST/CLOCKS_PER_SEC,durationT/CLOCKS_PER_SEC);
						SetDlgItemText(hDialog, IDC_STATIC_TIME,text);

						WCHAR text1[120];
						LPCTSTR pszFormat2 = TEXT("Trad;%2.3f;ST;%2.3f;Dif;%2.3f;%s;%s;%d;%d\n");
						StringCbPrintfW(text1, (120*sizeof(WCHAR)),pszFormat2,durationT/CLOCKS_PER_SEC,durationST/CLOCKS_PER_SEC,(durationT/CLOCKS_PER_SEC)-(durationST/CLOCKS_PER_SEC),GleftFile,GrightFile,GmaxDisp,GwindowSize);
						log(text1);
						}

				break;}
				}//switch (GET_WM_COMMAND_ID(wParam, lParam))
			break;
			}//fecha case WM_COMMAND:

		default:
		return(FALSE);
		}

	return(TRUE);
	}



int GetEncoderClsid(const WCHAR* format, CLSID* pClsid)
{
   UINT  num = 0;          // number of image encoders
   UINT  size = 0;         // size of the image encoder array in bytes

   ImageCodecInfo* pImageCodecInfo = NULL;

   GetImageEncodersSize(&num, &size);
   if(size == 0)
      return -1;  // Failure

   pImageCodecInfo = (ImageCodecInfo*)(malloc(size));
   if(pImageCodecInfo == NULL)
      return -1;  // Failure

   GetImageEncoders(num, size, pImageCodecInfo);

   for(UINT j = 0; j < num; ++j)
   {
      if( wcscmp(pImageCodecInfo[j].MimeType, format) == 0 )
      {
         *pClsid = pImageCodecInfo[j].Clsid;
         free(pImageCodecInfo);
         return j;  // Success
      }    
   }

   free(pImageCodecInfo);
   return -1;  // Failure
}


void logW(char *file,WCHAR *message)//write
	{
	FILE *fileptr;
	errno_t err;
	if( (err  = fopen_s( &fileptr, file, "w" )) ==0 )
	//if((fileptr=fopen(file,"w")) != NULL)
		{	
		fwprintf(fileptr,L"%s",message);
		fclose(fileptr);
		}
	}

void log(char *file,WCHAR *message)//append
	{
	FILE *fileptr;
	errno_t err;
	if( (err  = fopen_s( &fileptr, file, "a" )) ==0 )
	//if((fileptr=fopen(file,"a")) != NULL)
		{	
		fwprintf(fileptr,L"%s",message);
		fclose(fileptr);
		}
	}



void log(WCHAR *message)
	{
	FILE *fileptr;
	errno_t err;
	if( (err  = fopen_s( &fileptr, "log.csv", "a" )) ==0 )
	//if((fileptr=fopen("log.csv","a")) != NULL)
		{	
		fwprintf(fileptr,L"%s",message);
		fclose(fileptr);
		}
	}

//cuidados: N tem que ser impar e maior que 3
//			x tem que ser maior que 0+n
//			y tem que ser maior que 0+n
void sumFirstWindow(unsigned long width,unsigned long x,unsigned long y,unsigned long n,unsigned long *AggregationStrip,unsigned long *DispSelectLine,unsigned long stepLine)
	{
	//h WCHAR text[40];
	//h LPCTSTR pszFormat = TEXT("%d;%d;%0.0f;%0.0f\n");
	unsigned long xi,yi;
	unsigned long yiProdWidth;


	unsigned long tempSum;

	
	tempSum=0;
	for(yi=y-n;yi<=y+n;yi++)//no fundo equivale a um for de yi=0 at yi<windowSize, pois y  igual a n ento o for comea de yi=n-n=0 at yi<=n+n=2n repare que  <=, logo temos para windowSize=3, n=1 ento temos o for de yi=0 at yi<=2 que  a mesma coisa que yi<3
		{
		yiProdWidth=yi*width;
		for(xi=x-n;xi<=x+n;xi++)
			{
			tempSum=tempSum+AggregationStrip[yiProdWidth+xi];
			}
		}//for(yi=y-n

	DispSelectLine[stepLine+x]=tempSum;
	}

//cuidados: o kernel (x-1,y) tem que estar calculado
//			N tem que ser impar e maior que 3
//			x tem que ser maior que 0+n
//			y tem que ser maior que 0+n
///	t dando resultado negativo, como  possivel: descontinuidade.... deixe rodar na imagem inteira....
void sumNextWindow(unsigned long width,unsigned long x,unsigned long y,unsigned long n,unsigned long *AggregationStrip,unsigned long *DispSelectLine,unsigned long stepLine)
	{
	//WCHAR text[40];
	
	unsigned long xi,yi;
	unsigned long tempSum;

	tempSum=DispSelectLine[stepLine+(x-1)];//carrega tempSum com o valor (x-1,y)
	
	
	//remove a coluna anterior
	xi=x-n-1;
	for(yi=y-n;yi<=y+n;yi++)
		{
		tempSum=tempSum-AggregationStrip[(yi*width)+xi];//a subtrao no tem perigo de gerar resultado negativo, pois est retirando o que havia sido adicionado na rodada anterior
		tempSum=tempSum+AggregationStrip[(yi*width)+x+n];//adiciona a prxima coluna
		}//for(yi=y-n

	DispSelectLine[stepLine+x]=tempSum;

	}

//Mtodo Tradicional
//Matching Cost
void matchingCost(HDC hdc,unsigned int width,unsigned int height,unsigned int range)
	{
	void *voidSquaredDiff;
	//e WCHAR text[200];
	//h WCHAR text[40];
	//h LPCTSTR pszFormat = TEXT("%d;%d;%d;%d;%d;%d;%d;%0.0f\n");
   	unsigned long layerProdImgSize,yProdWidth,increment;
	unsigned int x,y,layer;
	unsigned long ImgSize;
	float tempL,tempR,tempDiff,Sdiff;
	IMGpixel *pointLocImgL,*pointLocImgR;
	float *pointLocSquaredDiff;

	if(range==0) range=1;//range=0  invalido
	ImgSize=width*height;
	voidSquaredDiff= new float[ImgSize*range];

	pointLocSquaredDiff=(float *)voidSquaredDiff;
	
	pointLocImgR=(IMGpixel *)voidImgR;

	startT=clock();//Contabiliza somente a execuo do cdigo de procura de correspondncias
	for(layer=0;layer<range;layer++)
		{
		layerProdImgSize=layer*ImgSize;//Calcula uma nica vez para cada layer 
		pointLocImgL=(IMGpixel *)voidImgL;
		
		for(y=0;y<height;y++)
			{
			yProdWidth=y*width;//Calcula uma nica vez para cada y 

			for(x=0;x<width;x++,pointLocImgL++)//,pointLocImgR++)//,pointLocSquaredDiff++ )
				{
				if(x>=(range-1))//se o range  10 a layer vai de 0 a 9, logo o minimo que eu posso aceitar de layer  9 que  range menos um, para que a subtrao de x no suba uma linha (para y=0 existe o risco de acessar memria no alocada)
					{
					increment=yProdWidth+(x-layer);//Calcula uma nica vez para cada x 

					tempL=(float)pointLocImgL->r;//eu uso ponteiro puro aqui, por ser mais rpido (no tem que fazer conta)
					//tempR=(float)pointLocImgR->r;
					tempR=(float)pointLocImgR[increment].r;
					tempDiff=tempL-tempR;
					Sdiff=tempDiff*tempDiff;
					
					tempL=(float)pointLocImgL->g;
					//tempR=(float)pointLocImgR->g;
					tempR=(float)pointLocImgR[increment].g;
					tempDiff=tempL-tempR;
					Sdiff=(tempDiff*tempDiff)+Sdiff;

			
					tempL=(float)pointLocImgL->b;
					//tempR=(float)pointLocImgR->b;
					tempR=(float)pointLocImgR[increment].b;
					tempDiff=tempL-tempR;
					Sdiff=(tempDiff*tempDiff)+Sdiff;


					pointLocSquaredDiff[layerProdImgSize+yProdWidth+x]=Sdiff;
					}//if(x>=(range-1))
				else
					pointLocSquaredDiff[layerProdImgSize+yProdWidth+x]=0;
				}//for(x=0
			}//for(y=0
		}//for(layer=0

	
	// Agregao
	aggregation(width,height,range,windowSizeForCompare,&pointLocSquaredDiff[0]);
	
	// Seleo
	selection(hdc,width,height,range,&pointLocSquaredDiff[0]);
	
	delete(voidSquaredDiff);
	}




//WTA (Winneer Take-All)
void selection(HDC hdc,unsigned long width,unsigned long height,unsigned int range,float *squaredDiff)
	{
	//WCHAR text[250];
	unsigned long yProdWidth;
	unsigned int x,y,layer;
	unsigned int disp;
	float SSDtemp;
	//diferenas entre tradicional e stripping technique (comentarios com //e)
	//e dispMap *pointLocDispMap;
	unsigned long *pointLocDispMap;
	unsigned int part,color;
	unsigned long ImgSize;

	ImgSize=width*height;

	part=255/range;
	
	

	//diferenas entre tradicional e stripping technique (comentarios com //e)
	voidDispMapLegacy= new unsigned long[width*height];//  deletado somente no fim do programa
	pointLocDispMap=(unsigned long *)voidDispMapLegacy;
	

	for(y=0;y<height;y++)
		{
		yProdWidth=y*width;//Calcula uma nica vez para cada y
		for(x=0;x<width;x++)
			{
			disp=0;//pressupoe que a layer 0 tem o menor valor de Soma dos Quadrados das Diferenaas
			SSDtemp=squaredDiff[yProdWidth+x];
			for(layer=1;layer<range;layer++)//como o range tem que ser no mnimo 1, logo layer pode comear a partir de 1, uma vez que eu j pressupus que 0  a menor disparidade
				{
				if(SSDtemp>squaredDiff[(layer*ImgSize)+yProdWidth+x])
					{
					disp=layer;
                    SSDtemp=squaredDiff[(layer*ImgSize)+yProdWidth+x];
					}
				}//for(layer=1
			color=part*disp;
			pointLocDispMap[yProdWidth+x]=color;//disp;
			
			// usado color e no o ponteiro pointLocDispMap[] pois para acessar os seus contedos  necessria multiplicao, logo  mais eficiente usar uma varivel j como o valor da cor
			}//	for(x=0	
		}//for(y=0
	finishT=clock(); //Contabiliza somente a execuo do cdigo, retirando a etapa para salvar o arquivo
	durationT=finishT-startT;
	

	Bitmap DispMap(GleftFile);//left);//i
	unsigned int xs,ys;
	unsigned long ysProdWidth;
	pointLocDispMap=(unsigned long *)voidDispMapLegacy;

	for (ys=0; ys<height;ys++)
		{
		ysProdWidth=ys*width;
		for (xs=0; xs<width;xs++)
			{
			color=pointLocDispMap[(ys*width)+xs];
			DispMap.SetPixel(xs, ys, Color(255,color,color,color)); //lembre-se o alfa TEM que ser 255
			}
		}
	

	CLSID  clsid;
    //GetEncoderClsid(L"image/jpeg", &clsid);//veja os encoders disponiveis no Windows 2000
	GetEncoderClsid(L"image/bmp", &clsid);
	Graphics graphics(hdc);//i
	
	
	DispMap.Save(disparityMap, &clsid, NULL);
	
	
	if(compare==false) graphics.DrawImage(&DispMap, 384+10, 0,384,288); //se estiver comparando, no apresenta na tela, pois a CorrespSearch() no apresenta. Para Tsukuba com janela 9 e Max Disp 16 a retirada desta linha economizou 20ms
	}


void sameLayer(dispMap *pointDispMap,unsigned long width,unsigned long height)
	{
	unsigned long x,y;
	unsigned long yProdWidth;
	int disp;

	disp=pointDispMap[0].disp;//pega a primeira disparidade como referncia
	for(y=0;y<height;y++)
		{
		yProdWidth=y*width;//Calcula uma nica vez para cada y
		for(x=0;x<width;x++)
			{
			if(pointDispMap[x+yProdWidth].disp==disp) 
				pointDispMap[x+yProdWidth].type=1;//Pixel no relevante, no se tornar vertice
			else
				{
				pointDispMap[x+yProdWidth].type=2;
				disp=pointDispMap[x+yProdWidth].disp;
				}//else
			}//for(x=0;x<width;x++)
		}//for(y=0;y<height;y++)

	disp=pointDispMap[0].disp;//pega a primeira disparidade como referncia
	for(x=0;x<width;x++)
		{
		for(y=0;y<height;y++)
			{
			yProdWidth=y*width;//Calcula uma nica vez para cada y
			if(pointDispMap[x+yProdWidth].disp!=disp) 
				{
				pointDispMap[x+yProdWidth].type=2;
				disp=pointDispMap[x+yProdWidth].disp;
				}//if(pointDispMap[x+yProdWidth].disp!=disp) 
			}//for(x=0;x<width;x++)
		}//for(y=0;y<height;y++)
	}


//Aggregation
void aggregation(unsigned long width,unsigned long height,unsigned int range,unsigned long Kernel,float *squaredDiff)
	{
	unsigned int layer;
	unsigned long layerProdImgSize;
	unsigned long ImgSize;

	ImgSize=width*height;

	for(layer=0;layer<range;layer++)
		{
		layerProdImgSize=layer*ImgSize;//Calcula uma nica vez para cada layer 
		aggregationOneLayer(width,height,range,Kernel,&squaredDiff[layerProdImgSize]);
		}
	}


//faz a convoluo usando um kernel NxN 
void aggregationOneLayer(unsigned long width,unsigned long height,unsigned int range,unsigned long Kernel,float *squaredDiff)
	{
	// WCHAR text[200];
	//h WCHAR text[40];
	//h LPCTSTR pszFormat = TEXT("%s,%d;%d;%0.0f\n");

	//float temp;
	unsigned long x,y,n;
	unsigned long yProdWidth;
	void *voidLocTempSquaredDiff;
	float *pointLocSquaredDiff,*pointLocTempSquaredDiff;

	if(Kernel%2==0)	{log(L"Kernel invalido, nmero par.\n");return;}
	if(Kernel<3)	{log(L"Kernel invalido, menor que 3.\n");return;}
	n=(Kernel-1)/2;//para N=3 n=1 para N=5 n=2 N  o tamanho do kernel e n  o incremento/decremento a ser feito em x e y

	//iGraphics graphics(hdc);
	//iBitmap BitmapL(L"tsukubaL.bmp");
	
	pointLocSquaredDiff=squaredDiff;

	voidLocTempSquaredDiff= new float[width*height];//Temporario
	pointLocTempSquaredDiff=(float *)voidLocTempSquaredDiff;

	for(y=0;y<height;y++)
		{
		yProdWidth=y*width;//Calcula uma nica vez para cada y

		//depois coloque os if do y aqui fora
		if(y==n)//primeira linha vlida para a agregao
			for(x=0;x<width;x++)
				{
				//borda de proteo:para width= 500 e n=1 o mximo x somente pode ser 499, isto , width-1-n
				//borda de proteo:para n=1 o mnimo y somente pode ser 1
				//borda de proteo:range=10 representa um deslocamento de disparidade(x-layer) na imagem direita de 10 pixels, logo o minimo x aceitavel  9 (range-1) 
				//considerando que o primeiro x vlido(em relao ao range) fica sendo 9 logo o pixel x=9 seria o primeiro vlido, agora considerando um n=2 o menor x aceitavel passa a ser 11
				//ento para range=10 e n=2 o primeiro x vlido  11 temos (range-1)+n
				if((x>=(range-1)+n)&&(x<=(width-1)-n))//borda no tratada
					{
					if(x==((range-1)+n))
						{
						sumFirstKernel(width,x,y,n,squaredDiff,pointLocTempSquaredDiff);
						}
					else
						{
						sumNextKernel(width,x,y,n,squaredDiff,pointLocTempSquaredDiff);
						}
					}//if((x>=(range-1)+n)
				else//do if((x>=(range-1)+n)
					{
					//i BitmapL.SetPixel(x, y, Color(255,0,125,255)); 
					pointLocTempSquaredDiff[yProdWidth+x]=0;
					}
				}//for(x=0
		if((y>n)&&(y<=(height-1)-n))//demais linhas vlidas para a agregao, otimizao da tcnica tradicional
			for(x=0;x<width;x++)
				{
				//borda de proteo:para width= 500 e n=1 o mximo x somente pode ser 499, isto , width-1-n
				//borda de proteo:para n=1 o mnimo y somente pode ser 1
				//borda de proteo:range=10 representa um deslocamento de disparidade(x-layer) na imagem direita de 10 pixels, logo o minimo x aceitavel  9 (range-1) 
				//considerando que o primeiro x vlido(em relao ao range) fica sendo 9 logo o pixel x=9 seria o primeiro vlido, agora considerando um n=2 o menor x aceitavel passa a ser 11
				//ento para range=10 e n=2 o primeiro x vlido  11 temos (range-1)+n
				if((x>=(range-1)+n)&&(x<=(width-1)-n))//borda no tratada
					{
					sumKernel(width,x,y,n,squaredDiff,pointLocTempSquaredDiff);
					}//if((x>=(range-1)+n)
				else//do if((x>=(range-1)+n)
					{
					//i BitmapL.SetPixel(x, y, Color(255,0,125,255)); 
					pointLocTempSquaredDiff[yProdWidth+x]=0;
					}
				}//for(x=0
		}//for(y=0

	//transfere o buffer temporrio: pointLocTempSquaredDiff
	//para o buffer geral: pointLocSquaredDiff
	//carrega a layer com a soma dos quadrados das diferenas


	//buffer temporrio
	 for(y=0;y<height;y++)
		{
		yProdWidth=y*width;//Calcula uma nica vez para cada y
		for(x=0;x<width;x++)
			pointLocSquaredDiff[yProdWidth+x]=pointLocTempSquaredDiff[yProdWidth+x];//carrega a layer com a soma dos quadrados das diferenas
		}

	delete(voidLocTempSquaredDiff);
	//i graphics.DrawImage(&BitmapL, 0, 300,BitmapL.GetWidth(),BitmapL.GetHeight());
	}

//cuidados: N tem que ser impar e maior que 3
//			x tem que ser maior que 0+n
//			y tem que ser maior que 0+n
void sumFirstKernel(unsigned long width,unsigned long x,unsigned long y,unsigned long n,float *squaredDiff,float *sumSquaredDiff)
	{
	//h WCHAR text[40];
	//h LPCTSTR pszFormat = TEXT("%d;%d;%0.0f;%0.0f\n");
	unsigned long xi,yi;
	unsigned long yiProdWidth;


	float tempSum;

	
	tempSum=0;
	for(yi=y-n;yi<=y+n;yi++)
		{
		yiProdWidth=yi*width;
		for(xi=x-n;xi<=x+n;xi++)
			{
			tempSum=tempSum+squaredDiff[yiProdWidth+xi];
			}
		}//for(yi=y-n

	sumSquaredDiff[(y*width)+x]=tempSum;
	}

//cuidados: o kernel (x-1,y) tem que estar calculado
//			N tem que ser impar e maior que 3
//			x tem que ser maior que 0+n
//			y tem que ser maior que 0+n
///	t dando resultado negativo, como  possivel: descontinuidade.... deixe rodar na imagem inteira....
void sumNextKernel(unsigned long width,unsigned long x,unsigned long y,unsigned long n,float *squaredDiff,float *sumSquaredDiff)
	{
	//WCHAR text[40];
	
	unsigned long xi,yi;
	float tempSum;

	tempSum=sumSquaredDiff[(y*width)+(x-1)];//carrega tempSum com o valor (x-1,y)
	
	
	//remove a coluna anterior
	xi=x-n-1;
	for(yi=y-n;yi<=y+n;yi++)
		{
		tempSum=tempSum-squaredDiff[(yi*width)+xi];//a subtrao no tem perigo de gerar resultado negativo, pois est retirando o que havia sido adicionado na rodada anterior
		tempSum=tempSum+squaredDiff[(yi*width)+x+n];//adiciona a prxima coluna
		}//for(yi=y-n

	sumSquaredDiff[(y*width)+x]=tempSum;
	}

void sumKernel(unsigned long width,unsigned long x,unsigned long y,unsigned long n,float *squaredDiff,float *sumSquaredDiff)
	{
	//WCHAR text[40];
	
	unsigned long xi,yProdWidthIn,yProdWidthOut;
	float tempSum;

	//note que aqui  y-1 pois o ponteiro  sumSquaredDiff
	tempSum=sumSquaredDiff[(((y-1)*width)+x)];//carrega tempSum com o valor (x,y-1)resultado da linha acima
	

	//note que aqui  (y-1-n) pois o ponteiro  squaredDiff
	yProdWidthOut=(y-1-n)*width;//uma linha da rodada anterior
	yProdWidthIn=(y+n)*width;//proxima linha
// as duas linhas acima poderiam ser otimizadas, sendo calculadas antes do for(x... que chamou sumKernel, de forma que no seria necessrio recalcular a cada chamada.
	
	for(xi=x-n;xi<=x+n;xi++)
			{
			tempSum=tempSum-squaredDiff[yProdWidthOut+xi];//retira custos da linha descartada. No tem perigo de dar negativo, (que seria um erro dificil de detectar) porque o valor que est sendo subtraido, havia sido adicionado na rodada anterior. 
			tempSum=tempSum+squaredDiff[yProdWidthIn+xi];//adiciona custos da linha adicionada.
			}//for(xi=x-n;xi<=x+n;xi++)

	sumSquaredDiff[(y*width)+x]=tempSum;
	}


void carregaImgBuffer(IMGpixel *pointLocImg,Bitmap *bitmap)
	{
	Color pixelColor;

	for (UINT y = 0; y < bitmap->GetHeight(); y ++)
		for (UINT x = 0; x < bitmap->GetWidth(); x ++,pointLocImg++ )
			{
			bitmap->GetPixel(x, y, &pixelColor);

			pointLocImg->a=pixelColor.GetA();
			pointLocImg->r=pixelColor.GetR();
			pointLocImg->g=pixelColor.GetG();
			pointLocImg->b=pixelColor.GetB();
			}
	}

void carregaDispMapBuffer(unsigned long *pointLocImg,Bitmap *bitmap)
	{
	Color pixelColor;

	for (UINT y = 0; y < bitmap->GetHeight(); y ++)
		for (UINT x = 0; x < bitmap->GetWidth(); x ++,pointLocImg++ )
			{
			bitmap->GetPixel(x, y, &pixelColor);

			
			//*pointLocImg==pixelColor.GetR();
			*pointLocImg=pixelColor.GetG();//como so tons de cinza vou carregar pelo verde, mais poderia ser qualquer cor uma vez que sendo tons de cinza todas so iguais.
			//*pointLocImg==pixelColor.GetB();
			}
	}



void deleteBuffer(void)
	{
	if(voidImgL!=0) delete(voidImgL);
	if(voidImgR!=0) delete(voidImgR);
	if(voidDispMap!=0) delete(voidDispMap);
	if(voidDispMapLegacy!=0) delete(voidDispMapLegacy);//delete(pointLocDispMap);

	if(Pad!=0)		delete (Pad);
	if(BitmapL!=0)	delete (BitmapL);
	if(BitmapR!=0)	delete (BitmapR);
	if(DispMap!=0)	delete (DispMap);

	}

void paint(HDC hdc)
	{
	Graphics graphics(hdc);
		
	if(imagesLoaded)
		{
		if(BitmapL==0)	BitmapL = new Bitmap(GleftFile);//left);
		
		if(BitmapR==0) BitmapR = new Bitmap(GrightFile);//right);
		

		if(ImgBufferLoaded==false)//carrega buffers bsicos, para permitir que no caso de portar para outro sistema operacional seja usado o buffer neste formato, ao invs do formato do GDI+
			{
			IMGpixel *pointLocImgL,*pointLocImgR;

			globalWidth=BitmapL->GetWidth();
			globalHeight=BitmapL->GetHeight();
	
			voidImgL= new IMGpixel[BitmapL->GetWidth()*BitmapL->GetHeight()];//  deletado somente no fim do programa
			voidImgR= new IMGpixel[BitmapR->GetWidth()*BitmapR->GetHeight()];//  deletado somente no fim do programa
	
			pointLocImgL=(IMGpixel *)voidImgL;
			pointLocImgR=(IMGpixel *)voidImgR;
	
			if(gradient)
				{	
				carregaImgBufferWithSobel(pointLocImgL,BitmapL);
				carregaImgBufferWithSobel(pointLocImgR,BitmapR);
				}
			else
				{
				carregaImgBuffer(pointLocImgL,BitmapL);
				carregaImgBuffer(pointLocImgR,BitmapR);
				}

			

            ImgBufferLoaded=true;
			}

		graphics.DrawImage(BitmapL, 0, 300,384,288);
		graphics.DrawImage(BitmapR, 384+10,300,384,288);

		WCHAR text[40];
		LPCTSTR pszFormat = TEXT("Left %d x %d\nRight %d x %d");
		StringCbPrintfW(text, (40*sizeof(WCHAR)),pszFormat, BitmapL->GetWidth(),BitmapL->GetHeight(),BitmapR->GetWidth(),BitmapR->GetHeight());
		Text(hdc,text);
		}
	else
		{
		if(Pad==0) Pad = new Bitmap(hInstanceSave, MAKEINTRESOURCE(IDB_BITMAP1));//pad enquanto no gera o mapa de disparidade
		graphics.DrawImage(Pad, 0, 300,384,288);
		graphics.DrawImage(Pad, 384+10,300,384,288);
		}


	if(dispGenerated)//quando o mapa de disparidade  gerado pela CorrespSearch() o buffer interno j est carregado, porm quando o mapa de disparidade  lido  precisso carregar o buffer
		{
		if(DispMap==0) DispMap = new Bitmap(GdisparityMap);
		graphics.DrawImage(DispMap, 384+10, 0,384,288);

		if(LoadOnlyDispMap==true)
			{	
			//Mapa de disparidade lido sem ter sido carregado pela CorrespSearch()
			//Carrega os tamanhos da imagem caso seja lido somente o mapa de disparidade
			if(globalWidth==0)	globalWidth=DispMap->GetWidth();
			if(globalHeight==0)	globalHeight=DispMap->GetHeight();
			//void *voidDispMap; mudou para variavel global que ser usada em D3D9.cpp para montar a malha 3D
			unsigned long *pointLocDispMap;

			voidDispMap= new unsigned long[globalWidth*globalHeight];
			pointLocDispMap=(unsigned long *)voidDispMap;
			//*****************************************************************
			carregaDispMapBuffer(pointLocDispMap,DispMap);//Carrega voidDispMap, pois o mapa de disparidades  carregado diretamente do arquivo sem chamar CorrespSearch()
			LoadOnlyDispMap=false; // parra no carregar repetidas vezes
			}
		}
	else
		{
		if(Pad==0) Pad = new Bitmap(hInstanceSave, MAKEINTRESOURCE(IDB_BITMAP1));//pad enquanto no gera o mapa de disparidade
		graphics.DrawImage(Pad, 384+10, 0,384,288);
		}
  	}


VOID OnPaint2(HDC hdc)
{
   WCHAR text[120];
   Graphics graphics(hdc);
   //carrega a imagem
	
   if(Pad==0) Pad = new Bitmap(hInstanceSave, MAKEINTRESOURCE(IDB_BITMAP1));//pad enquanto no gera o mapa de disparidade
   if(BitmapL==0) BitmapL = new Bitmap(left);
   if(BitmapR==0) BitmapR = new Bitmap(right);

   globalWidth=BitmapL->GetWidth();
   globalHeight=BitmapL->GetHeight();
   
	Color pixelColor;

	// -----------------------------------------------------------------------------------
	
	
	IMGpixel *pointLocImgL,*pointLocImgR;
	
	voidImgL= new IMGpixel[BitmapL->GetWidth()*  BitmapL->GetHeight()];//  deletado somente no fim do programa
	voidImgR= new IMGpixel[BitmapR->GetWidth()*  BitmapR->GetHeight()];//  deletado somente no fim do programa
	
	pointLocImgL=(IMGpixel *)voidImgL;
	pointLocImgR=(IMGpixel *)voidImgR;

	
	carregaImgBuffer(pointLocImgL,BitmapL);
	carregaImgBuffer(pointLocImgR,BitmapR);


	

	clock_t startLegacy, finishLegacy,startNew, finishNew;
	double  durationLegacy,durationNew;
	
	
	
	startNew=clock();
	FastCorrespSearch(hdc,BitmapL->GetWidth(),BitmapL->GetHeight(),MaxdispForCompare,1,windowSizeForCompare);//tsukuba low
	

	finishNew=clock();
	durationNew=finishNew-startNew;

	startLegacy=clock();
	matchingCost(hdc,BitmapL->GetWidth(),BitmapL->GetHeight(),MaxdispForCompare);
		
	finishLegacy=clock();
	durationLegacy=finishLegacy-startLegacy;
	

	LPCTSTR pszFormat1 = TEXT("Legacy;%2.3f;New;%2.3f;Dif;%2.3f;%s;%s;%d;%d\n");
	StringCbPrintfW(text, (120*sizeof(WCHAR)),pszFormat1,durationLegacy/CLOCKS_PER_SEC,durationNew/CLOCKS_PER_SEC,(durationLegacy/CLOCKS_PER_SEC)-(durationNew/CLOCKS_PER_SEC),left,right,MaxdispForCompare,windowSizeForCompare);
	log(text);
	
	
	// -----------------------------------------------------------------------------------

   graphics.DrawImage(BitmapL, 0, 300,384,288);
   graphics.DrawImage(BitmapR, 384+10,300,384,288);
   
   
   LPCTSTR pszFormat = TEXT("Left %d x %d\nRight %d x %d");
   StringCbPrintfW(text, (40*sizeof(WCHAR)),pszFormat, BitmapL->GetWidth(),BitmapL->GetHeight(),BitmapR->GetWidth(),BitmapR->GetHeight());
   Text(hdc,text);
   
}	

void Text(HDC hdc,WCHAR *text)
{
   Graphics    graphics(hdc);
   SolidBrush  brush(Color(255, 0, 120, 255));
   FontFamily  fontFamily(L"Times New Roman");
   Font        font(&fontFamily, 16, FontStyleRegular, UnitPixel);
   PointF      pointF(10.0f, 590.0f);
   
   graphics.DrawString(text, -1, &font, pointF, &brush);
}


void carregaImgBufferWithSobel(IMGpixel *pointImg,Bitmap *bitmap)
	{
	//lembre-se linha x coluna
	int knlV[][3]=	{
					1, 0, -1,
					2, 0, -2,
					1, 0, -1
					};
	int knlH[][3]=	{
					-1, -2, -1,
					 0,  0,  0,
					 1,  2,  1
					};

	IMGpixel *pointLocImg;
	pointLocImg=pointImg;
	
	Color z1,z2,z3;
	Color z4,z5,z6;
	Color z7,z8,z9;

	ARGB black = 0x00000000;
	
	BYTE alfa=255;
	BYTE red,green,blue;
	int resRed,resGreen,resBlue;
	int resRedH,resGreenH,resBlueH;
	int resRedV,resGreenV,resBlueV;
	//Color result;

	int x,y;
	
	for(y=0;y<(int)bitmap->GetHeight();y++)
		for(x=0;x<(int)bitmap->GetWidth();x++,pointLocImg++)
			{
			if(((x-1)<0)||((y-1)<0)) z1.SetValue(black);
			else bitmap->GetPixel(x-1,y-1,&z1);
						
			if((y-1)<0) z2.SetValue(black);
			else bitmap->GetPixel(x,y-1,&z2);

			if(((x+1)>(int)bitmap->GetWidth())||((y-1)<0)) z3.SetValue(black);
			else bitmap->GetPixel(x+1,y-1,&z3);

			if((x-1)<0) z4.SetValue(black);
			else bitmap->GetPixel(x-1,y,&z4);

			bitmap->GetPixel(x,y,&z5);

			if((x+1)>(int)bitmap->GetWidth()) z6.SetValue(black);
			else bitmap->GetPixel(x+1,y,&z6);

			if(((x-1)<0)||((y+1)>(int)bitmap->GetHeight())) z7.SetValue(black);
			else bitmap->GetPixel(x-1,y+1,&z7);


			if((y+1)>(int)bitmap->GetHeight()) z8.SetValue(black);
			else bitmap->GetPixel(x,y+1,&z8);
			
			if(((x+1)>(int)bitmap->GetWidth())||((y+1)>(int)bitmap->GetHeight())) z9.SetValue(black);
			else bitmap->GetPixel(x+1,y+1,&z9);

			
			
			// Tratamento para o Red
			resRedH=(z1.GetR()*knlH[0][0])+(z2.GetR()*knlH[0][1])+(z3.GetR()*knlH[0][2])+
					(z4.GetR()*knlH[1][0])+(z5.GetR()*knlH[1][1])+(z6.GetR()*knlH[1][2])+
					(z7.GetR()*knlH[2][0])+(z8.GetR()*knlH[2][1])+(z9.GetR()*knlH[2][2]);
			
			
			
			if(resRedH<0)		resRedH=-resRedH;
			if(resRedH>255)		resRedH=255;

			resRedV=(z1.GetR()*knlV[0][0])+(z2.GetR()*knlV[0][1])+(z3.GetR()*knlV[0][2])+
					(z4.GetR()*knlV[1][0])+(z5.GetR()*knlV[1][1])+(z6.GetR()*knlV[1][2])+
					(z7.GetR()*knlV[2][0])+(z8.GetR()*knlV[2][1])+(z9.GetR()*knlV[2][2]);

			
			if(resRedV<0)		resRedV=-resRedV;
			if(resRedV>255)		resRedV=255;


			resRed=resRedH+resRedV;
			if(resRed>255)		resRed=255; //No precisa da proteo para o negativo, pois sempre vir numeros positivos

			red=(BYTE) resRed;
			
			// Tratamento para o Green
			resGreenH=(z1.GetG()*knlH[0][0])+(z2.GetG()*knlH[0][1])+(z3.GetG()*knlH[0][2])+
					  (z4.GetG()*knlH[1][0])+(z5.GetG()*knlH[1][1])+(z6.GetG()*knlH[1][2])+
					  (z7.GetG()*knlH[2][0])+(z8.GetG()*knlH[2][1])+(z9.GetG()*knlH[2][2]);

			
			if(resGreenH<0)		resGreenH=-resGreenH;
			if(resGreenH>255)	resGreenH=255;

			resGreenV=(z1.GetG()*knlV[0][0])+(z2.GetG()*knlV[0][1])+(z3.GetG()*knlV[0][2])+
					  (z4.GetG()*knlV[1][0])+(z5.GetG()*knlV[1][1])+(z6.GetG()*knlV[1][2])+
					  (z7.GetG()*knlV[2][0])+(z8.GetG()*knlV[2][1])+(z9.GetG()*knlV[2][2]);

			
			if(resGreenV<0)		resGreenV=-resGreenV;
			if(resGreenV>255)	resGreenV=255;

			resGreen=resGreenH+resGreenV;
			if(resGreen>255)	resGreen=255; //No precisa da proteo para o negativo, pois sempre vir numeros positivos

			green=(BYTE) resGreen;

			// Tratamento para o Blue
			resBlueH=(z1.GetB()*knlH[0][0])+(z2.GetB()*knlH[0][1])+(z3.GetB()*knlH[0][2])+
					 (z4.GetB()*knlH[1][0])+(z5.GetB()*knlH[1][1])+(z6.GetB()*knlH[1][2])+
					 (z7.GetB()*knlH[2][0])+(z8.GetB()*knlH[2][1])+(z9.GetB()*knlH[2][2]);

			
			if(resBlueH<0)		resBlueH=-resBlueH;
			if(resBlueH>255)	resBlueH=255;

			resBlueV=(z1.GetB()*knlV[0][0])+(z2.GetB()*knlV[0][1])+(z3.GetB()*knlV[0][2])+
					 (z4.GetB()*knlV[1][0])+(z5.GetB()*knlV[1][1])+(z6.GetB()*knlV[1][2])+
					 (z7.GetB()*knlV[2][0])+(z8.GetB()*knlV[2][1])+(z9.GetB()*knlV[2][2]);

			
			if(resBlueV<0)		resBlueV=-resBlueV;
			if(resBlueV>255)	resBlueV=255;

			resBlue=resBlueH+resBlueV;
			if(resBlue>255)	resBlue=255; //No precisa da proteo para o negativo, pois sempre vir numeros positivos

			blue=(BYTE) resBlue;

			// Set da combinao aps Sobel
			pointLocImg->a=alfa;
			pointLocImg->r=red;
			pointLocImg->g=green;
			pointLocImg->b=blue;
			}

	// Aplica na imagem Origem
	pointLocImg=pointImg;
	
	for(y=0;y<(int)bitmap->GetHeight();y++)
		for(x=0;x<(int)bitmap->GetWidth();x++,pointLocImg++)
			{
			bitmap->SetPixel(x,y,Color(255,pointLocImg->r,pointLocImg->g,pointLocImg->b));//lembre-se o alfa tem que ser 255
			//bitmap->SetPixel(x,y,Color(255,255,0,255));
			}

	}



//veja para mudar  a Aggregation Strip para float, pois quando a janela for muito grande maior que 148x148 no pior caso (regio preta versus branca) pode extrapolar a capacidade do unsigened long... j com float tudo bem... , outra cois mude tambm o cdigo para a o Tradicional Approach (usar float).Em 17/09 : acho que j est com float
//Novo algoritmo: Stripping Technique - Otimizado para aumentar a performance
void FastCorrespSearch(HDC hdc,unsigned int width,unsigned int height,unsigned int maxDisp,unsigned int maxLineVar,int windowSize)
	{
	maxDisparity=maxDisp;//variavel global usada em D3D9 para construo da interface 3D
	unsigned long n;
	int yVar;//long pois no for que ser usado ser colocado na varive searchRegionY que  long
	//WCHAR text[250];
	
	//protees
	if(windowSize%2==0)	{log(L"windowSize invalido, nmero par.\n");return;}
	if(windowSize<3)	{log(L"windowSize invalido, menor que 3.\n");return;}
	if(maxDisp<1)		{log(L"maxDisp invalido, menor que 1.\n");return;}
	if(maxLineVar<1)	{log(L"maxLineVar invalido, menor que 1.\n");return;}
	if(maxLineVar%2==0)	{log(L"maxLineVar invalido, nmero par.\n");return;}//funciona como a window, porm aceita tamanho 1, que na prtica significa um busca 1D

	n=(windowSize-1)/2;//para N=3 n=1 para N=5 n=2 N  o tamanho do kernel e n  o incremento/decremento a ser feito em x e y
	yVar=(maxLineVar-1)/2;//para maxLineVar=7 yVar=3


	//Alocao de memria para a Faixa de Aggregao (Aggregation Strip)
//Mude para Float, pois em janela muito grande o resultado pode no caber
	unsigned long stripSize,numberOfStrips,aggregationStripSize;
	void *voidAggregationStrip;
	unsigned long *pointLocAggregationStrip;

	if(maxDisp<=0) maxDisp=1;//maxDisp=0  invalido
	if(maxLineVar<=0) maxLineVar=1;//maxLineVar=0  invalido

	stripSize=width*(windowSize+1);//a altura da strip  o windowSize, o +1 se refere a linha de para armazenamento temporrio no processo de Fast Aggregation
	numberOfStrips=maxDisp*maxLineVar;
	aggregationStripSize=stripSize*numberOfStrips;

	voidAggregationStrip= new unsigned long[aggregationStripSize];
	pointLocAggregationStrip=(unsigned long *)voidAggregationStrip;
	//*****************************************************************

	//Alocao de memria para as linhas de seleo de disparidade
	unsigned long dispSelectLineSize;
	void *voidDispSelectLine;
	unsigned long *pointLocDispSelectLine;

	dispSelectLineSize=width*numberOfStrips;//deve ter uma linha para cada faixa

	voidDispSelectLine= new unsigned long[dispSelectLineSize];
	pointLocDispSelectLine=(unsigned long *)voidDispSelectLine;
	//*****************************************************************
	
	//Alocao de memria para o Mapa de Disparidades
	
	//void *voidDispMap; mudou para variavel global que ser usada em D3D9.cpp para montar a malha 3D
	unsigned long *pointLocDispMap;

	voidDispMap= new unsigned long[width*height];
	pointLocDispMap=(unsigned long *)voidDispMap;
	//*****************************************************************
	
	WCHAR text[10];
	LPCTSTR pszFormat = TEXT("%0.0f %%");
  
	
	Bitmap DispMap(GleftFile);//i usei o left s para gerar um bitmap de mesmas propores, poderia ser o right


	unsigned int x,yFull,searchRegionX,searchRegionY;
	int y;//tem que aceitar negativo pois vai ser um fator de variao de uma linha, isto , ir tanto para cima (-) quanto para baixo (+)
	unsigned long stepStrip,stepLineStrip,stepImageL,stepImageR,stepImageUnderStripIn,stepImageUnderStripOut,stepLine,increment;
	unsigned long yFullProdWidth;
	long jumpLineIn,jumpLineOut;

	startST=clock();//Contabiliza somente a execuo do cdigo de procura de correspondncias
	

	for(yFull=0;yFull<height;yFull++)//yFull sempre esta no centro da Strip
	{
	yFullProdWidth=yFull*width;
	StringCbPrintfW(text, (10*sizeof(WCHAR)),pszFormat,((float)yFull/(height))*100 );
	SetDlgItemText(hDialog, IDC_STATIC_PROGRESS,text);
	
	long tempL,tempR,tempDiff,Sdiff;
	IMGpixel *pointLocImgL,*pointLocImgR;
	
	if((yFull>=n)&&(yFull<height-n))
	{
	if(yFull==n)//primeira linha valida
		{
		//Matching Cost - Strips da primeira linha vlida
		//Para um pixels na imagem da esquerda eu procuro um conjunto de pixels(disparidade) na imagem direita
		pointLocImgR=(IMGpixel *)voidImgR;//aponta ponteiro local para a imagem da Direita, dentro do for este ponteiro no  incrementado, s por isso ele  definido fora do for
		for(searchRegionY=0;searchRegionY<maxLineVar;searchRegionY++)
			for(stepStrip=0,searchRegionX=0;searchRegionX<maxDisp;searchRegionX++)
				{
				stepStrip=(searchRegionY*maxDisp*stripSize)+searchRegionX*stripSize;//(searchRegionY*maxDisp*stripSize) equivale a um pulo de linha de strips 
				pointLocImgL=(IMGpixel *)voidImgL;
		
				for(y=0;y<windowSize;y++)//Carga da primeira Aggregation Strip, a altura da strip  igual a windowSize
					{
					stepLineStrip=y*width;
					//para y>=yVar se maxLineVar for 5 o yVar ser 2 logo o searchRegionY vai oscilar de -2 at 2(inclusive), por consequncia o y ser somado a -2 o que resulta que o menor y permitido seja 2, logo y tem que ser >= a yVar 
					//para y<=(height-(1+yVar)) se height  768 que  de 0 at 767 s pode ir at 765 que  height-(1+var)
					if(	(y>=yVar)&&(y<=((int)height-(1+yVar)))	)// na primeira linha vlida nem precisava a segunda parte y<=(height-(1+yVar)) porm optei por manter para evitar futuros erros em manutenes do cdigo
						{
						//stepImageR=(y+searchRegionY)*width;//Calcula uma nica vez para cada y. o searchRegionY ir fazer o y oscilar para cima e para baixo do valor que referncia da imagem da esqueda, pois altera stepImage que  referncia para increment que  usado para deslocar a imagem da direita.
						stepImageR=(y+searchRegionY-yVar)*width;//tem que ter um if antes protejendo, pois quando y=0 e searchRegionY=0 pode haver acesso a uma regio de memria no alocada

						for(x=0;x<width;x++,pointLocImgL++)//,pointLocImgR++)//,pointLocSquaredDiff++ )
							{
							if(x>=(maxDisp-1))//se o maxDisp  10 a searchRegionX vai de 0 a 9, logo o minimo que eu posso aceitar de searchRegionX  9 que  maxDisp menos um, para que a subtrao de x no suba uma linha (para y=0 existe o risco de acessar memria no alocada)
								{
								increment=stepImageR+(x-searchRegionX);//Calcula uma nica vez para cada x 
							
								tempL=pointLocImgL->r;//eu uso ponteiro puro aqui, por ser mais rpido (no tem que fazer conta)
								tempR=pointLocImgR[increment].r;
								tempDiff=tempL-tempR;
								Sdiff=tempDiff*tempDiff;
					
			
								tempL=pointLocImgL->g;
								tempR=pointLocImgR[increment].g;
								tempDiff=tempL-tempR;
								Sdiff=(tempDiff*tempDiff)+Sdiff;
						
			
								tempL=pointLocImgL->b;
								tempR=pointLocImgR[increment].b;
								tempDiff=tempL-tempR;
								Sdiff=(tempDiff*tempDiff)+Sdiff;
					

								pointLocAggregationStrip[stepStrip+stepLineStrip+x]=Sdiff;
								}//if(x>=(maxDisp-1))
							else//if(x>=(maxDisp-1))
								pointLocAggregationStrip[stepStrip+stepLineStrip+x]=195075;//(255*255)+(255*255)+(255*255)=195075 tem que ser alto para evitar falsa correspondncia, lembre-se que na fase de Evidence Aggregation  somasse os pontos da janela e que na fase de Disparity Seletion  escolhido o menor valor (WTA), se fosse um valor baixo como 0 pode fazer parecer um winner 
							}//for(x=0
						}//if(y>=yVar)
					else//if(y>=yVar)
						{
						for(x=0;x<width;x++)//havia um bug aqui, eu havia esquecido de colocar o for, e por isso era preenchido somente um pixel
							pointLocAggregationStrip[stepStrip+stepLineStrip+x]=195075;//(255*255)+(255*255)+(255*255)=195075 tem que ser alto para evitar falsa correspondncia, lembre-se que na fase de Evidence Aggregation  somasse os pontos da janela e que na fase de Disparity Seletion  escolhido o menor valor (WTA), se fosse um valor baixo como 0 pode fazer parecer um winner 
						}
					}//for(y=0
				}//for(searchRegionX=0
		

	//Evidence Aggregation - Strips da primeira linha vlida
	for(searchRegionY=0;searchRegionY<maxLineVar;searchRegionY++)//aqui o for  diferente do for usado para esta mesma varivel no Matching Cost, pois l ela  usada principalmente para deslocar a linha de procura da imagem da direita o que exige que ela oscile de -yVar at yVar, como para stepStrip searchRegionY precisa oscilar de 0 at maxLineVar-1  usada uma operao searchRegionY+yVar para conseguir esta oscilao. Como aqui o objetivo  varrer as Aggregation Strips e as Disparity Selection Lines faz mais sentido que o for oscile de 0 at maxLineVar-1
		for(stepLine=0,searchRegionX=0;searchRegionX<maxDisp;searchRegionX++)
		{
		stepLine=(searchRegionY*maxDisp*width)+(searchRegionX*width);//Calcula uma nica vez para cada line, varivel para salto entre as Disparity Selection Lines, (searchRegionY*maxDisp*stripSize) equivale a um pulo de linha de strips 
		stepStrip=(searchRegionY*maxDisp*stripSize)+(searchRegionX*stripSize);//Calcula uma nica vez para cada strip, varivel de salto entre da Aggregation Strip, (searchRegionY*maxDisp*stripSize) equivale a um pulo de linha de strips 
		if((yFull>=n)&&(yFull<height-n))
//acho que est incoerente, se a borda no  tratada para a disparidade (lado esquerdo do mapa de disparidades) porque aqui no tem uma proteo igual (	(y>=yVar)&&(y<=((int)height-(1+yVar))), ????
				{
				for(x=0;x<width;x++)//,pointLocImgR++)//,pointLocSquaredDiff++ )
					{
					//borda de proteo:para width= 500 e n=1 o mximo x somente pode ser 499, isto , width-1-n
					//borda de proteo:para n=1 o mnimo y somente pode ser 1
					//borda de proteo:range=10 representa um deslocamento de disparidade(x-layer) na imagem direita de 10 pixels, logo o minimo x aceitavel  9 (range-1) 
					//considerando que o primeiro x vlido(em relao ao range) fica sendo 9 logo o pixel x=9 seria o primeiro vlido, agora considerando um n=2 o menor x aceitavel passa a ser 11
					//ento para range=10 e n=2 o primeiro x vlido  11 temos (range-1)+n
					if((x>=(maxDisp-1)+n)&&(x<=(width-1)-n))//borda no tratada
						{
						if(x==((maxDisp-1)+n))
							{//usa-se n no lugar de y pois n  a metade da altura da strip ex. para windowSize=3 n=(3-1)/2=2/2=1 logo temo y=0,y=1 e y=2 sendo que 1  o do meio, que  igual a n
							sumFirstWindow(width,x,n,n,&pointLocAggregationStrip[stepStrip],pointLocDispSelectLine,stepLine);
							}
						else
							{
							sumNextWindow(width,x,n,n,&pointLocAggregationStrip[stepStrip],pointLocDispSelectLine,stepLine);
							}
						}//if((x>=(range-1)+n)
					else//dentro do X precisa ter um tratamento para zerar a parte no tratada, o que no  necessrio para o y, pois para y no tratado, no tem strip e nem selectionLine.
						{
						//i BitmapL.SetPixel(x, y, Color(255,0,125,255)); 
						pointLocDispSelectLine[stepLine+x]=0;
						}
					}//for(x=0
				}//if((yFull>=n)&&(yFull<height-n))
		}//for(searchRegionX=0

	jumpLineOut=0;//Na agregao esta linha sai
	jumpLineIn=windowSize;//Na agregao esta linha entra
	}//if(yFull==n)
	
	
	if((n<yFull)&&(yFull<height-n)) //Demais linhas at a tima vlida, exceto a primeira vlida
		{
		//Matching Cost - Strips das demais linhas at a tima vlida, exceto a primeira vlida
		pointLocImgR=(IMGpixel *)voidImgR;//aponta ponteiro local para a imagem da Direita, dentro do for este ponteiro no  incrementado, s por isso ele  definido fora do for
		stepImageUnderStripIn=jumpLineIn*width;//Indica a linha que ser descartada da rodada anterior recebendo o novo dado, que ser adicionado na agregao (na primeira vez  a linha de posio igual WindowSize que  a ultima linha, dai roda para a primeira (0) e assim por diante, sempre depois da jumpLineOut
		stepImageUnderStripOut=jumpLineOut*width;//Indica a linha que ser removida na agregao, na proxima rodada esta ser a In, isto , um novo dado ir substitui-la (na primeira vez  a linha de posio igual 0 que  a primeira linha, dai roda para a segunda (1) e assim por diante, sempre a frete da jumpLineIn

		
		for(searchRegionY=0;searchRegionY<maxLineVar;searchRegionY++)
			for(stepStrip=0,searchRegionX=0;searchRegionX<maxDisp;searchRegionX++)
				{
				stepStrip=(searchRegionY*maxDisp*stripSize)+(searchRegionX*stripSize);//(searchRegionY*maxDisp*stripSize) equivale a um pulo de linha de strips 
				y=yFull+n;//y ser a prxima linha abaixo, pois a demais j esto dentro da Aggregation Strip do loop anterior
				
				if(	(y>=yVar)&&(y<=((int)height-(1+yVar)))	)// na primeira linha vlida(if(yFull==n)) nem precisava a segunda parte y<=(height-(1+yVar)) porm optei por manter para evitar futuros erros em manutenes do cdigo
					{
					//stepImageR=(y+searchRegionY)*width;//Calcula uma nica vez para cada y. o searchRegionY ir fazer o y oscilar para cima e para baixo do valor que referncia da imagem da esqueda, pois altera stepImage que  referncia para increment que  usado para deslocar a imagem da direita.
					stepImageR=(y+searchRegionY-yVar)*width;
					stepImageL=y*width;//Calcula uma nica vez para cada y 
					
					pointLocImgL=(IMGpixel *)voidImgL;
					pointLocImgL+=stepImageL;//avana para a linha certa
					for(x=0;x<width;x++,pointLocImgL++)//,pointLocImgR++)//,pointLocSquaredDiff++ )
						{
						if(x>=(maxDisp-1))//se o maxDisp  10 a searchRegionX vai de 0 a 9, logo o minimo que eu posso aceitar de searchRegionX  9 que  maxDisp menos um, para que a subtrao de x no suba uma linha (para y=0 existe o risco de acessar memria no alocada)
							{
							increment=stepImageR+(x-searchRegionX);//Calcula uma nica vez para cada x 

							tempL=pointLocImgL->r;//eu uso ponteiro puro aqui, por ser mais rpido (no tem que fazer conta)
							tempR=pointLocImgR[increment].r;
							tempDiff=tempL-tempR;
							Sdiff=tempDiff*tempDiff;
									
							tempL=pointLocImgL->g;
							tempR=pointLocImgR[increment].g;
							tempDiff=tempL-tempR;
							Sdiff=(tempDiff*tempDiff)+Sdiff;
										
							tempL=pointLocImgL->b;
							tempR=pointLocImgR[increment].b;
							tempDiff=tempL-tempR;
							Sdiff=(tempDiff*tempDiff)+Sdiff;
							
							pointLocAggregationStrip[stepStrip+stepImageUnderStripIn+x]=Sdiff;
							}//if(x>=(maxDisp-1))
						else
							pointLocAggregationStrip[stepStrip+stepImageUnderStripIn+x]=195075;//(255*255)+(255*255)+(255*255)=195075 tem que ser alto para evitar falsa correspondncia, lembre-se que na fase de Evidence Aggregation  somasse os pontos da janela e que na fase de Disparity Seletion  escolhido o menor valor (WTA), se fosse um valor baixo como 0 pode fazer parecer um winner 
						}//for(x=0
					}//if(y>=yVar)
				else//if(y>=yVar)
					{
					for(x=0;x<width;x++)//havia um bug aqui, eu havia esquecido de colocar o for, e por isso era preenchido somente um pixel
						pointLocAggregationStrip[stepStrip+stepImageUnderStripIn+x]=195075;//(255*255)+(255*255)+(255*255)=195075 tem que ser alto para evitar falsa correspondncia, lembre-se que na fase de Evidence Aggregation  somasse os pontos da janela e que na fase de Disparity Seletion  escolhido o menor valor (WTA), se fosse um valor baixo como 0 pode fazer parecer um winner 
					}
				}//for(searchRegionX=0
	
	
		//Evidence Aggregation - Strips das demais linhas at a tima vlida, exceto a primeira vlida
		for(searchRegionY=0;searchRegionY<maxLineVar;searchRegionY++)//aqui o for  diferente do for usado para esta mesma varivel no Matching Cost, pois l ela  usada principalmente para deslocar a linha de procura da imagem da direita o que exige que ela oscile de -yVar at yVar, como para stepStrip searchRegionY precisa oscilar de 0 at maxLineVar-1  usada uma operao searchRegionY+yVar para conseguir esta oscilao. Como aqui o objetivo  varrer as Aggregation Strips e as Disparity Selection Lines faz mais sentido que o for oscile de 0 at maxLineVar-1
			for(stepLine=0,searchRegionX=0;searchRegionX<maxDisp;searchRegionX++)
			{
			stepLine=(searchRegionY*maxDisp*width)+(searchRegionX*width);//Calcula uma nica vez para cada line, varivel para salto entre as Disparity Selection Lines, (searchRegionY*maxDisp*stripSize) equivale a um pulo de linha de strips 
			stepStrip=(searchRegionY*maxDisp*stripSize)+(searchRegionX*stripSize);//Calcula uma nica vez para cada strip, varivel de salto entre da Aggregation Strip, (searchRegionY*maxDisp*stripSize) equivale a um pulo de linha de strips 
			if((yFull>=n)&&(yFull<height-n))
//acho que est incoerente, se a borda no  tratada para a disparidade (lado esquerdo do mapa de disparidades) porque aqui no tem uma proteo igual (	(y>=yVar)&&(y<=((int)height-(1+yVar))), ????
				{
				for(x=0;x<width;x++)//,pointLocImgR++)//,pointLocSquaredDiff++ )
					{
					//borda de proteo:para width= 500 e n=1 o mximo x somente pode ser 499, isto , width-1-n
					//borda de proteo:para n=1 o mnimo y somente pode ser 1
					//borda de proteo:range=10 representa um deslocamento de disparidade(x-layer) na imagem direita de 10 pixels, logo o minimo x aceitavel  9 (range-1) 
					//considerando que o primeiro x vlido(em relao ao range) fica sendo 9 logo o pixel x=9 seria o primeiro vlido, agora considerando um n=2 o menor x aceitavel passa a ser 11
					//ento para range=10 e n=2 o primeiro x vlido  11 temos (range-1)+n
					if((x>=(maxDisp-1)+n)&&(x<=(width-1)-n))//borda no tratada
						{
//testar com o cdigo aqui para melhorar o desempenho sem chamar funo... o mesmo vale para o tradicional
//(no matching cost use SAD)... 
						sumPair(x,stepImageUnderStripOut,stepImageUnderStripIn,n,&pointLocAggregationStrip[stepStrip],pointLocDispSelectLine,stepLine);
						}//if((x>=(maxDisp-1)+n)&&(x<=(width-1)-n))//borda no tratada
					else//dentro do X precisa ter um tratamento para zerar a parte no tratada, o que no  necessrio para o y, pois para y no tratado, no tem strip e nem selectionLine.
						{
						//i BitmapL.SetPixel(x, y, Color(255,0,125,255)); 
						pointLocDispSelectLine[stepLine+x]=0;
						}
					}//for(x=0
				}//if((yFull>=n)&&(yFull<height-n))
			}//for(searchRegionX=0

				
		jumpLineOut+=1;
		jumpLineIn+=1;
		if(jumpLineOut==(windowSize+1)) jumpLineOut=0;
		if(jumpLineIn==(windowSize+1))	jumpLineIn=0;
		}//if((n<yFull)&&(yFull<height-n))


	}//if((yFull>=n)&&(yFull<height-n))
	
	

	//Disparity Selection WTA (Winneer Take-All)
	unsigned long bestResult;
	unsigned long disp;
	unsigned int part,color;
	part=255/maxDisp;

	for(x=0;x<width;x++)//,pointLocImgR++)//,pointLocSquaredDiff++ )
		{
		//Pressupoe que a primeira linha (primeira strp) j  p melhor resultado
		disp=0;
		bestResult=pointLocDispSelectLine[x];//pressupoe que  a primeira linha stepLine=0
		for(searchRegionY=0;searchRegionY<maxLineVar;searchRegionY++)
			for(stepLine=0,searchRegionX=0;searchRegionX<maxDisp;searchRegionX++)
				{
				stepLine=(searchRegionY*maxDisp*width)+searchRegionX*width;//Calcula uma nica vez para cada line, varive para salto entre as Disparity Selection Lines, (searchRegionY*maxDisp*stripSize) equivale a um pulo de linha de strips 
				//stepLine=searchRegionX*width;//Calcula uma nica vez para cada linha
				if((yFull>=n)&&(yFull<height-n))
					if(bestResult>pointLocDispSelectLine[stepLine+x])
						{
						disp=searchRegionX;
						bestResult=pointLocDispSelectLine[stepLine+x];
						}
				//else no  necessrio, pois disp e bestResult j tem um valor pressuposto.
				}//for(searchRegionX
		color=part*disp;
		pointLocDispMap[(yFullProdWidth)+x]=color;//disp;
		}//for(x=0
	}//for(yFull=0
	finishST=clock(); //Contabiliza somente a execuo do cdigo, retirando a etapa para salvar o arquivo

	durationST=finishST-startST;

	unsigned int xs,ys;
	unsigned long ysProdWidth;
	unsigned int color;
	pointLocDispMap=(unsigned long *)voidDispMap;

	for (ys=0; ys<height;ys++)
		{
		ysProdWidth=ys*width;
		for (xs=0; xs<width;xs++)
			{
			color=pointLocDispMap[(ysProdWidth)+xs];
			DispMap.SetPixel(xs, ys, Color(255,color,color,color)); //lembre-se o alfa TEM que ser 255
			}
		}

	CLSID  clsid;
    //GetEncoderClsid(L"image/jpeg", &clsid);//veja os encoders disponiveis no Windows 2000
	GetEncoderClsid(L"image/bmp", &clsid);
	Graphics graphics(hdc);//i
	
	//No futuro fazer um tratamento para o usurio selecionar o formato do arquivo de sada do diparity map
	DispMap.Save(GdisparityMap, &clsid, NULL);
	
	//graphics.DrawImage(&DispMap, DispMap.GetWidth()+10, 0,DispMap.GetWidth(),DispMap.GetHeight());

	dispGenerated=true;

	delete(voidAggregationStrip);
	delete(voidDispSelectLine);
	}


//cuidados: N tem que ser impar e maior que 3
//			x tem que ser maior que 0+n
//			y tem que ser maior que 0+n
void sumPair(unsigned long x,unsigned long stepImageUnderStripOut,unsigned long stepImageUnderStripIn,unsigned long n,unsigned long *AggregationStrip,unsigned long *DispSelectLine,unsigned long stepLine)
	{
	//h WCHAR text[40];
	//h LPCTSTR pszFormat = TEXT("%d;%d;%0.0f;%0.0f\n");
	unsigned long xi;


	unsigned long tempSum;

	tempSum=DispSelectLine[stepLine+x];//guarda o valor anterior
	
	for(xi=x-n;xi<=x+n;xi++)
			{
			tempSum=tempSum-AggregationStrip[stepImageUnderStripOut+xi];//retira custos da linha descartada da strip. No tem perigo de dar negativo, (que seria um erro dificil de detectar) porque o valor que est sendo subtraido, havia sido adicionado na rodada anterior. 
			tempSum=tempSum+AggregationStrip[stepImageUnderStripIn+xi];//adiciona custos da linha adicionada na strip
			}//for(xi=x-n;xi<=x+n;xi++)

	DispSelectLine[stepLine+x]=tempSum;//salva valor atual
	}

